package edu.berkeley.sbp;
import java.io.*;
import java.util.*;
import java.lang.reflect.*;
import java.lang.ref.*;
import edu.berkeley.sbp.util.*;
import edu.berkeley.sbp.*;
import edu.berkeley.sbp.*;

/** an element which matches exactly one input token */
public abstract class Atom<T extends Token> extends Element {

    private final Topology<T> rt;

    public Atom(Topology<T> rt) { this.rt = rt; }

    Topology<T> top() { return rt; }

    void reachable(HashSet<Sequence.Position> h) { /* do-nothing */ }

    /** equality is based on the underlying <tt>Topology</tt> */
    public int hashCode() { return rt.hashCode(); }
    
    /** equality is based on the underlying <tt>Topology</tt> */
    public boolean equals(Object o) { return o != null && o instanceof Atom && ((Atom)o).rt.equals(rt); }

    /** declared abstract to force subclasses to override it in a useful manner */
    public abstract String toString();
}

